library buffer_with_count;

import 'dart:async';
import 'package:flat_map/flat_map.dart';
import 'package:window_with_count/window_with_count.dart';

class BufferWithCount<S, T> extends StreamEventTransformer {

  final int _count;

  const BufferWithCount(this._count);

  Stream<T> bind(Stream<S> stream) {
    return stream.transform(new WindowWithCount(this._count, this._count))
                 .transform(new FlatMap((stream) => stream.toList().asStream()))
                 .where((n) => n.length > 0);
  }

}